#include <bits/stdc++.h>

using namespace std;
int nzd(long long int a,long long int b)
{
    if(b==0)
    {
        return a;
    }
    return nzd(b,a%b);
}

int main()
{
    std::ios::sync_with_stdio(false);
    cin.tie(NULL);
    int t;
    cin>>t;
    for(int i=0;i<t;i++)
    {
        int n,m;
        vector <long long int> a;
        long long int k,b;
        cin>>n>>m;
        for(int j=0;j<n;j++)
        {
            long long int t;
            cin>>t;
            a.push_back(t);
        }
        sort(a.begin(),a.end());
        k=a[1]-a[0];
        for(int j=2;j<n;j++)
        {
            k=nzd(k,a[2]-a[0]);
            if(k==1)
            {
                return 1;
            }
        }
        int res=1;
        for(int j=0;j<m;j++)
        {
            cin>>b;
            if((abs(b-a[0])%k)==0)
            {
                res=0;
            }
        }
        cout<<res<<endl;
    }
    return 0;
}